/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webshop.storage;

import generated.Customers;
import java.io.File;
import java.util.List;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletContext;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import webshop.model.Customer;

/**
 *
 * @author emsi
 */
public class CustomerStorage implements Storage<Customer> {
    
    private JAXBContext context;
    private ServletContext servletContext;
    
    public CustomerStorage(ServletContext servletContext) {
        this.servletContext = servletContext;
        try {
            this.context = JAXBContext.newInstance(generated.Customers.class);
        } catch (JAXBException ex) {
            Logger.getLogger(ItemStorage.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    public int create(Customer customer) {
        try {
            final String fileLocation = "WEB-INF/xml/customers.xml";
            Marshaller marshaller = this.context.createMarshaller();
            Unmarshaller unmarshaller = this.context.createUnmarshaller();
            generated.Customers customersResult = (generated.Customers) unmarshaller.unmarshal(
                new File(this.servletContext.getResource(fileLocation).getPath())
            );
            
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            
            Customers.Row row = new Customers.Row();
            row.setEmail(customer.getEmail());
            row.setFirstName(customer.getFirstName());
            row.setName(customer.getName());
            
            customer.setId(new Random().nextInt());
            row.setId(customer.getId());
            
            customersResult.getRow().add(row);
            
            marshaller.marshal(customersResult, new File(this.servletContext.getResource(fileLocation).getPath()));
            
            return customer.getId();
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public List<Customer> read() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Customer read(int id) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean update(Customer o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean delete(int id) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
