<%-- 
    Document   : detail
    Created on : 22.04.2016, 14:46:29
    Author     : emsi
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="style.css">
        <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
        <title>Detail</title>
    </head>
    <body>
        <div class="header">
            <div class="text">
                <a href="/shop">
                    SARG SCOUT 24
                </a>
                <a href="/cart" class="cart-icon">
                    <i class="material-icons">shopping_cart</i>
                </a>
            </div>
        </div>
        <table class="item">
            <tr>
                <td class="image"></td>
                <td class="name">
                    ${item.name}
                </td>
                <td class="buying" rowspan="2">
                    <div class="price">
                        <fmt:formatNumber value="${item.price}" type="currency"/>
                    </div>
                    <div class="inventory">
                        Noch ${item.inventory} Stück auf Lager
                    </div>
                    <form method="POST" action="cart">
                        <input type="number" name="amount" value="1" /><br />
                        <input type="hidden" name="id" value="${item.id}" />
                        <button tpye="submit">In den Warenkorb</button>
                    </form>
                </td>
            </tr>
            <tr>
                <td class="image">
                    <img src="${item.image}"/>
                </td>
                <td class="description">
                    ${item.description}<br /><br />
                    Hersteller: ${item.brand}
                </td>
            </tr>
        </table>
    </body>
</html>
